/*
Copyright (c) 2019-2020 Péter Magyar

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef STAT_DATA_H
#define STAT_DATA_H

#include "core/resource.h"
#include "scene/resources/curve.h"

#include "level_stat_data.h"
#include "stat.h"
#include "stat_data_entry.h"

class StatData : public Resource {
	GDCLASS(StatData, Resource);

public:
	Ref<StatDataEntry> get_stat_data_int(int index);
	void set_stat_data_int(int index, Ref<StatDataEntry> entry);

	Ref<StatDataEntry> get_stat_data_enum(Stat::StatId stat_id);
	void set_stat_data_enum(Stat::StatId stat_id, Ref<StatDataEntry> entry);

	Ref<LevelStatData> get_level_stat_data();
	void set_level_stat_data(Ref<LevelStatData> value);

	void get_stat_for_stat(Ref<Stat> stat);

	StatData();

protected:
	static void _bind_methods();

private:
	Ref<StatDataEntry> _entries[Stat::STAT_ID_TOTAL_STATS];

	Ref<LevelStatData> _level_stat_data;
};

#endif
